/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison interface for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

#ifndef YY_YY_PARSER_H_INCLUDED
# define YY_YY_PARSER_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    MINTOKEN = 258,                /* MINTOKEN  */
    FORTIMES = 259,                /* FORTIMES  */
    FORIN = 260,                   /* FORIN  */
    FORALLIN = 261,                /* FORALLIN  */
    MAKELIST = 262,                /* MAKELIST  */
    MAKERANGELIST = 263,           /* MAKERANGELIST  */
    SUB = 264,                     /* SUB  */
    SUBLIST = 265,                 /* SUBLIST  */
    BOOL = 266,                    /* BOOL  */
    LOC = 267,                     /* LOC  */
    STATE = 268,                   /* STATE  */
    STATIC = 269,                  /* STATIC  */
    LIST = 270,                    /* LIST  */
    CALL = 271,                    /* CALL  */
    iCALL = 272,                   /* iCALL  */
    iLAMBDA = 273,                 /* iLAMBDA  */
    iEXISTS = 274,                 /* iEXISTS  */
    iPROCESS = 275,                /* iPROCESS  */
    iPREFIX = 276,                 /* iPREFIX  */
    iFOR = 277,                    /* iFOR  */
    iFORTIMES = 278,               /* iFORTIMES  */
    iFORIN = 279,                  /* iFORIN  */
    iPROJ = 280,                   /* iPROJ  */
    iSEMI = 281,                   /* iSEMI  */
    iAND = 282,                    /* iAND  */
    ENV = 283,                     /* ENV  */
    BND = 284,                     /* BND  */
    MEMBLOCK = 285,                /* MEMBLOCK  */
    iIF = 286,                     /* iIF  */
    iSYSTEM = 287,                 /* iSYSTEM  */
    iLEN = 288,                    /* iLEN  */
    iOR = 289,                     /* iOR  */
    iUNDEFINED = 290,              /* iUNDEFINED  */
    iREMEMBER = 291,               /* iREMEMBER  */
    RUN = 292,                     /* RUN  */
    HELP = 293,                    /* HELP  */
    WHILE = 294,                   /* WHILE  */
    FOR = 295,                     /* FOR  */
    IN = 296,                      /* IN  */
    TIMES = 297,                   /* TIMES  */
    REPEAT = 298,                  /* REPEAT  */
    EXISTS = 299,                  /* EXISTS  */
    EXISTSF = 300,                 /* EXISTSF  */
    FORALL = 301,                  /* FORALL  */
    TO = 302,                      /* TO  */
    SIZE = 303,                    /* SIZE  */
    TRUE = 304,                    /* TRUE  */
    FALSE = 305,                   /* FALSE  */
    LAMBDA = 306,                  /* LAMBDA  */
    SKIP = 307,                    /* SKIP  */
    EMPTY = 308,                   /* EMPTY  */
    MORE = 309,                    /* MORE  */
    RANLEN = 310,                  /* RANLEN  */
    INFINITE = 311,                /* INFINITE  */
    END = 312,                     /* END  */
    NAME = 313,                    /* NAME  */
    STRING = 314,                  /* STRING  */
    FLOAT = 315,                   /* FLOAT  */
    INT = 316,                     /* INT  */
    MPZ = 317,                     /* MPZ  */
    MPX = 318,                     /* MPX  */
    MPFR = 319,                    /* MPFR  */
    PROJ = 320,                    /* PROJ  */
    FIXLIST = 321,                 /* FIXLIST  */
    VARLIST = 322,                 /* VARLIST  */
    NPREV = 323,                   /* NPREV  */
    SHOWMEM = 324,                 /* SHOWMEM  */
    EXIT = 325,                    /* EXIT  */
    SHOWTRACE = 326,               /* SHOWTRACE  */
    SHOWSTATE = 327,               /* SHOWSTATE  */
    ABORT = 328,                   /* ABORT  */
    BREAK = 329,                   /* BREAK  */
    RETURN = 330,                  /* RETURN  */
    CONTINUE = 331,                /* CONTINUE  */
    LEAP = 332,                    /* LEAP  */
    STEP = 333,                    /* STEP  */
    PASSLIMIT = 334,               /* PASSLIMIT  */
    VERBOSITY = 335,               /* VERBOSITY  */
    PRINTLEVEL = 336,              /* PRINTLEVEL  */
    DEBUGLEVEL = 337,              /* DEBUGLEVEL  */
    STATEPRINT = 338,              /* STATEPRINT  */
    REDUNDANCY = 339,              /* REDUNDANCY  */
    CALLBYNAME = 340,              /* CALLBYNAME  */
    ASSIGNAHEAD = 341,             /* ASSIGNAHEAD  */
    BREAKISABORT = 342,            /* BREAKISABORT  */
    HOPCHOP = 343,                 /* HOPCHOP  */
    PATH = 344,                    /* PATH  */
    HELPDIR = 345,                 /* HELPDIR  */
    INFILE = 346,                  /* INFILE  */
    OUTFILE = 347,                 /* OUTFILE  */
    TIMESTEP = 348,                /* TIMESTEP  */
    RANDSEED = 349,                /* RANDSEED  */
    ZRANDSEED = 350,               /* ZRANDSEED  */
    ZRANDOMMAX = 351,              /* ZRANDOMMAX  */
    MAXRANDLEN = 352,              /* MAXRANDLEN  */
    PRECISION = 353,               /* PRECISION  */
    MPFRPRECISION = 354,           /* MPFRPRECISION  */
    MPFRRND = 355,                 /* MPFRRND  */
    FLRND = 356,                   /* FLRND  */
    RANDOM = 357,                  /* RANDOM  */
    RRANDOM = 358,                 /* RRANDOM  */
    SRANDOM = 359,                 /* SRANDOM  */
    SRRANDOM = 360,                /* SRRANDOM  */
    ZRANDOM = 361,                 /* ZRANDOM  */
    ZRRANDOM = 362,                /* ZRRANDOM  */
    FRANDOM = 363,                 /* FRANDOM  */
    FRRANDOM = 364,                /* FRRANDOM  */
    STATENUMBER = 365,             /* STATENUMBER  */
    NIL = 366,                     /* NIL  */
    LBRACE = 367,                  /* LBRACE  */
    PROCESS = 368,                 /* PROCESS  */
    LPAREN = 369,                  /* LPAREN  */
    LBRACK = 370,                  /* LBRACK  */
    RBRACE = 371,                  /* RBRACE  */
    RPAREN = 372,                  /* RPAREN  */
    RBRACK = 373,                  /* RBRACK  */
    BAR = 374,                     /* BAR  */
    SEMI = 375,                    /* SEMI  */
    IMPLIES = 376,                 /* IMPLIES  */
    OR = 377,                      /* OR  */
    WHERE = 378,                   /* WHERE  */
    AND = 379,                     /* AND  */
    IF = 380,                      /* IF  */
    THEN = 381,                    /* THEN  */
    IFX = 382,                     /* IFX  */
    ELSE = 383,                    /* ELSE  */
    ELSEIF = 384,                  /* ELSEIF  */
    DEFINE = 385,                  /* DEFINE  */
    SET = 386,                     /* SET  */
    FORMAT = 387,                  /* FORMAT  */
    ATANTWO = 388,                 /* ATANTWO  */
    DO = 389,                      /* DO  */
    UNTIL = 390,                   /* UNTIL  */
    HISTORY = 391,                 /* HISTORY  */
    GETS = 392,                    /* GETS  */
    IS = 393,                      /* IS  */
    ASSN = 394,                    /* ASSN  */
    UASSN = 395,                   /* UASSN  */
    SKIPUASSN = 396,               /* SKIPUASSN  */
    DEFAULTS = 397,                /* DEFAULTS  */
    KEEP = 398,                    /* KEEP  */
    THE = 399,                     /* THE  */
    LT = 400,                      /* LT  */
    LE = 401,                      /* LE  */
    EQ = 402,                      /* EQ  */
    GE = 403,                      /* GE  */
    GT = 404,                      /* GT  */
    NEQ = 405,                     /* NEQ  */
    LEN = 406,                     /* LEN  */
    PLUS = 407,                    /* PLUS  */
    MINUS = 408,                   /* MINUS  */
    MULT = 409,                    /* MULT  */
    DIV = 410,                     /* DIV  */
    MOD = 411,                     /* MOD  */
    POWER = 412,                   /* POWER  */
    MPXAND = 413,                  /* MPXAND  */
    MPXIOR = 414,                  /* MPXIOR  */
    MPXXOR = 415,                  /* MPXXOR  */
    PREFIX = 416,                  /* PREFIX  */
    ALWAYS = 417,                  /* ALWAYS  */
    SOMETIME = 418,                /* SOMETIME  */
    HALT = 419,                    /* HALT  */
    FIN = 420,                     /* FIN  */
    INIT = 421,                    /* INIT  */
    STB = 422,                     /* STB  */
    MEM = 423,                     /* MEM  */
    INPUT = 424,                   /* INPUT  */
    WINPUT = 425,                  /* WINPUT  */
    OUTPUT = 426,                  /* OUTPUT  */
    PEEK = 427,                    /* PEEK  */
    CHOPSTAR = 428,                /* CHOPSTAR  */
    NOT = 429,                     /* NOT  */
    NEXT = 430,                    /* NEXT  */
    WNEXT = 431,                   /* WNEXT  */
    PREV = 432,                    /* PREV  */
    TYPE = 433,                    /* TYPE  */
    ASCII = 434,                   /* ASCII  */
    STRUCT = 435,                  /* STRUCT  */
    LOAD = 436,                    /* LOAD  */
    SYSTEM = 437,                  /* SYSTEM  */
    UMINUS = 438,                  /* UMINUS  */
    UPLUS = 439,                   /* UPLUS  */
    CEIL = 440,                    /* CEIL  */
    FLOOR = 441,                   /* FLOOR  */
    RINT = 442,                    /* RINT  */
    SQRT = 443,                    /* SQRT  */
    ITOF = 444,                    /* ITOF  */
    EXPO = 445,                    /* EXPO  */
    LOG = 446,                     /* LOG  */
    LOGTEN = 447,                  /* LOGTEN  */
    SIN = 448,                     /* SIN  */
    COS = 449,                     /* COS  */
    TAN = 450,                     /* TAN  */
    ASIN = 451,                    /* ASIN  */
    ACOS = 452,                    /* ACOS  */
    ATAN = 453,                    /* ATAN  */
    SINH = 454,                    /* SINH  */
    COSH = 455,                    /* COSH  */
    TANH = 456,                    /* TANH  */
    FABS = 457,                    /* FABS  */
    ITOMPZ = 458,                  /* ITOMPZ  */
    ITOMPX = 459,                  /* ITOMPX  */
    MPZTOI = 460,                  /* MPZTOI  */
    MPXTOI = 461,                  /* MPXTOI  */
    ITOMPFR = 462,                 /* ITOMPFR  */
    MPZTOMPFR = 463,               /* MPZTOMPFR  */
    MPXTOMPFR = 464,               /* MPXTOMPFR  */
    MPZTOMPX = 465,                /* MPZTOMPX  */
    MPXTOMPZ = 466,                /* MPXTOMPZ  */
    MPFRTOF = 467,                 /* MPFRTOF  */
    FTOMPFR = 468,                 /* FTOMPFR  */
    ITOSTR = 469,                  /* ITOSTR  */
    MPZTOSTR = 470,                /* MPZTOSTR  */
    FTOSTR = 471,                  /* FTOSTR  */
    MPXTOSTR = 472,                /* MPXTOSTR  */
    MPFRTOSTR = 473,               /* MPFRTOSTR  */
    STRTOVAL = 474,                /* STRTOVAL  */
    STRTOI = 475,                  /* STRTOI  */
    STRTOF = 476,                  /* STRTOF  */
    STRTOMPZ = 477,                /* STRTOMPZ  */
    STRTOMPX = 478,                /* STRTOMPX  */
    STRTOMPFR = 479,               /* STRTOMPFR  */
    MPXCOM = 480,                  /* MPXCOM  */
    REFER = 481,                   /* REFER  */
    DEREF = 482,                   /* DEREF  */
    COMMA = 483,                   /* COMMA  */
    MAXTOKEN = 484,                /* MAXTOKEN  */
    MQS = 485,                     /* MQS  */
    IDN = 486,                     /* IDN  */
    MDMPFR = 487,                  /* MDMPFR  */
    EIMPFR = 488,                  /* EIMPFR  */
    MDF = 489,                     /* MDF  */
    EIF = 490,                     /* EIF  */
    EIMPZ = 491,                   /* EIMPZ  */
    EIMPX = 492,                   /* EIMPX  */
    H1 = 493,                      /* H1  */
    STL = 494,                     /* STL  */
    IPTL = 495,                    /* IPTL  */
    ERI = 496,                     /* ERI  */
    ERA = 497,                     /* ERA  */
    ERFL = 498,                    /* ERFL  */
    DUPL = 499,                    /* DUPL  */
    UNK = 500                      /* UNK  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define MINTOKEN 258
#define FORTIMES 259
#define FORIN 260
#define FORALLIN 261
#define MAKELIST 262
#define MAKERANGELIST 263
#define SUB 264
#define SUBLIST 265
#define BOOL 266
#define LOC 267
#define STATE 268
#define STATIC 269
#define LIST 270
#define CALL 271
#define iCALL 272
#define iLAMBDA 273
#define iEXISTS 274
#define iPROCESS 275
#define iPREFIX 276
#define iFOR 277
#define iFORTIMES 278
#define iFORIN 279
#define iPROJ 280
#define iSEMI 281
#define iAND 282
#define ENV 283
#define BND 284
#define MEMBLOCK 285
#define iIF 286
#define iSYSTEM 287
#define iLEN 288
#define iOR 289
#define iUNDEFINED 290
#define iREMEMBER 291
#define RUN 292
#define HELP 293
#define WHILE 294
#define FOR 295
#define IN 296
#define TIMES 297
#define REPEAT 298
#define EXISTS 299
#define EXISTSF 300
#define FORALL 301
#define TO 302
#define SIZE 303
#define TRUE 304
#define FALSE 305
#define LAMBDA 306
#define SKIP 307
#define EMPTY 308
#define MORE 309
#define RANLEN 310
#define INFINITE 311
#define END 312
#define NAME 313
#define STRING 314
#define FLOAT 315
#define INT 316
#define MPZ 317
#define MPX 318
#define MPFR 319
#define PROJ 320
#define FIXLIST 321
#define VARLIST 322
#define NPREV 323
#define SHOWMEM 324
#define EXIT 325
#define SHOWTRACE 326
#define SHOWSTATE 327
#define ABORT 328
#define BREAK 329
#define RETURN 330
#define CONTINUE 331
#define LEAP 332
#define STEP 333
#define PASSLIMIT 334
#define VERBOSITY 335
#define PRINTLEVEL 336
#define DEBUGLEVEL 337
#define STATEPRINT 338
#define REDUNDANCY 339
#define CALLBYNAME 340
#define ASSIGNAHEAD 341
#define BREAKISABORT 342
#define HOPCHOP 343
#define PATH 344
#define HELPDIR 345
#define INFILE 346
#define OUTFILE 347
#define TIMESTEP 348
#define RANDSEED 349
#define ZRANDSEED 350
#define ZRANDOMMAX 351
#define MAXRANDLEN 352
#define PRECISION 353
#define MPFRPRECISION 354
#define MPFRRND 355
#define FLRND 356
#define RANDOM 357
#define RRANDOM 358
#define SRANDOM 359
#define SRRANDOM 360
#define ZRANDOM 361
#define ZRRANDOM 362
#define FRANDOM 363
#define FRRANDOM 364
#define STATENUMBER 365
#define NIL 366
#define LBRACE 367
#define PROCESS 368
#define LPAREN 369
#define LBRACK 370
#define RBRACE 371
#define RPAREN 372
#define RBRACK 373
#define BAR 374
#define SEMI 375
#define IMPLIES 376
#define OR 377
#define WHERE 378
#define AND 379
#define IF 380
#define THEN 381
#define IFX 382
#define ELSE 383
#define ELSEIF 384
#define DEFINE 385
#define SET 386
#define FORMAT 387
#define ATANTWO 388
#define DO 389
#define UNTIL 390
#define HISTORY 391
#define GETS 392
#define IS 393
#define ASSN 394
#define UASSN 395
#define SKIPUASSN 396
#define DEFAULTS 397
#define KEEP 398
#define THE 399
#define LT 400
#define LE 401
#define EQ 402
#define GE 403
#define GT 404
#define NEQ 405
#define LEN 406
#define PLUS 407
#define MINUS 408
#define MULT 409
#define DIV 410
#define MOD 411
#define POWER 412
#define MPXAND 413
#define MPXIOR 414
#define MPXXOR 415
#define PREFIX 416
#define ALWAYS 417
#define SOMETIME 418
#define HALT 419
#define FIN 420
#define INIT 421
#define STB 422
#define MEM 423
#define INPUT 424
#define WINPUT 425
#define OUTPUT 426
#define PEEK 427
#define CHOPSTAR 428
#define NOT 429
#define NEXT 430
#define WNEXT 431
#define PREV 432
#define TYPE 433
#define ASCII 434
#define STRUCT 435
#define LOAD 436
#define SYSTEM 437
#define UMINUS 438
#define UPLUS 439
#define CEIL 440
#define FLOOR 441
#define RINT 442
#define SQRT 443
#define ITOF 444
#define EXPO 445
#define LOG 446
#define LOGTEN 447
#define SIN 448
#define COS 449
#define TAN 450
#define ASIN 451
#define ACOS 452
#define ATAN 453
#define SINH 454
#define COSH 455
#define TANH 456
#define FABS 457
#define ITOMPZ 458
#define ITOMPX 459
#define MPZTOI 460
#define MPXTOI 461
#define ITOMPFR 462
#define MPZTOMPFR 463
#define MPXTOMPFR 464
#define MPZTOMPX 465
#define MPXTOMPZ 466
#define MPFRTOF 467
#define FTOMPFR 468
#define ITOSTR 469
#define MPZTOSTR 470
#define FTOSTR 471
#define MPXTOSTR 472
#define MPFRTOSTR 473
#define STRTOVAL 474
#define STRTOI 475
#define STRTOF 476
#define STRTOMPZ 477
#define STRTOMPX 478
#define STRTOMPFR 479
#define MPXCOM 480
#define REFER 481
#define DEREF 482
#define COMMA 483
#define MAXTOKEN 484
#define MQS 485
#define IDN 486
#define MDMPFR 487
#define EIMPFR 488
#define MDF 489
#define EIF 490
#define EIMPZ 491
#define EIMPX 492
#define H1 493
#define STL 494
#define IPTL 495
#define ERI 496
#define ERA 497
#define ERFL 498
#define DUPL 499
#define UNK 500

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 33 "parser.y"

    int tokentype;
    NODEPTR nodetype;

#line 562 "parser.h"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif




int yyparse (void);


#endif /* !YY_YY_PARSER_H_INCLUDED  */
